program PROGR_3964TEST;  	{Datei: 3964TEST.PAS}
                                { Testprogramm fr 3964R - Kommunikation
                                  Letzte nderung 23.10.91
                                  Version 2.E. }

{$M 30000,0,644360}


USES CRT, DOS, ml4bib, util;  {ML4BIB.TPU Version 1.H.}

CONST  TERMCHR=#255;


       PAR_NR_SSTATUS     =   1; {Sendestatus}
       PAR_NR_SERR        =  23; {Sendefehler (Bitmap)}
       PAR_NR_SP_LG       =  25; {Sendepufferlnge}
       PAR_NR_SRP_LG      =  27; {Sendereaktionspufferlnge}
       PAR_NR_SPHASE      =  42; {interne Sendephase}
       PAR_NR_SERRPH      =  44; {Sendephase, in der der letzte Fehler aufgetreten ist}

       PAR_NR_ESTATUS     =  2;  {Empfangsstatus}
       PAR_NR_EERR        = 24;  {Empfangsfehler (Bitmap)}
       PAR_NR_EP_LG       = 29;  {Empfangspufferlnge}
       PAR_NR_ERP_LG      = 31;  {Empfangsreaktionspufferlnge}
       PAR_NR_EPHASE      = 41;  {interne Empfangsphase}
       PAR_NR_EERRPH      = 43;  {Empfangsphase, in der der letzte Fehler aufgetreten ist}

       PAR_NR_IRGEN       = 15;  {PC-Interrupt-Generierung}
       PAR_NR_REAKTELE    = 17;  {1 = Reaktionstelegramm enable ,0 = disable}
       PAR_NR_DOMINANZ    =  3;  {Dominanz:  0 = keine Dominanz,  1 = Dominanz}

      F1 = ';'; F2 = '<'; F3 = '='; F4 = '>'; F5 = '?';
      F6 = '@'; F7 = 'A'; F8 = 'B'; F9 = 'C'; F10 = 'D';
      up = 'H'; down = 'P'; left = 'K'; right = 'M';
      pageup = 'I'; pagedown = 'Q'; home = 'G'; Ende = 'O';


TYPE arr = array [1..1024] of byte;

     KanalRecTyp     = record
                        Task,Pgm  : byte;        {Task- und Programmnummer}
                        SP,SRP,                  {relative Adressen der Puffer}
                        EP,ERP    : string;
                        Arbeit    : boolean;     {Wahr, wenn ein Request
                                                  zu bearbeiten ist !}
                        pgmok     : boolean;
                       end;
     KanalRecArrTyp  = array [0..7] of KanalRecTyp;



VAR
    ch        : Char;
    err       : byte;
    stemp,
    stemp1,
    stemp2    : string;


var
    logfile : text;

    SSTATUS, SERR, SP_LG, SRP_LG,
    SPHASE, SERRPH, ESTATUS, EERR,
    EP_LG, ERP_LG, EPHASE, EERRPH,
    REAKTELE                        : byte;

    KanalRec : KanalRecArrTyp;
    Puffer : arr;


    Kanalreclg : word;
    Arbeitoffs : word;

    Stepmodus,
    Dauertest,
    Autoreak  : boolean;


(*****************************************************************************
*          Status- und Fehlerausgabe auf Bildschirm und Logdatei             *
******************************************************************************)
procedure log(s : string);
begin
  window(1,15,80,24);
  gotoxy(1,10);
  writeln(s);
  writeln(logfile,s);
  window(1,1,80,25);
end;
(*****************************************************************************)

(*****************************************************************************
*                     Schreibe ein Byte bitweise                             *
******************************************************************************)
function bit(b:integer) : string;
var j : integer;
    s :string;
begin
  s:='';
  for j:=1 to 8 do begin
    if b and 128 > 0 then s:=s+'1' else s:=s+'0';
    b:=b shl 1;
  end;
  bit:=s;
end;
(*****************************************************************************)

{$F+}

(* User-Interrupt-Service-Routine *)
procedure IntProc;
var Message : byte;
begin
  ml4_set_mark(100);
  if ml4_reacting then ;
  ml4_set_mark(101);
  Message:=ml4_get_message;
  KanalRec[Message-$60].Arbeit:=true;
end;

(****************************************************************************)


PROCEDURE MY_recovery;
var c : char;
    ERRSTR : ARRAY [1..10] OF STRING;
    stemp     : string; {Hilfsstring}
    i,j : INTEGER;
    regs    : registers;
    b : byte;

begin
  FILLCHAR(ERRSTR,sizeof(errstr),' ');
  with regs do begin
    ah:=18; {Statusmeldung}
    intr(softint,regs);
    I:=1;
    ERRSTR[i]:='************ Fehlermeldung des PC - MODULAR-4 Treibers *****************************';
    inc(i);
    if ah and 128 = 128 then begin
      ERRSTR[i]:='* Kommunikationsversuch nach Fehler ohne Reinitalisierung';
      inc(i);
      ah:=ah and 127;
    end;
    str(ah:3,stemp);
    case ah of
    1: ERRSTR[i]:='* Fehler'+stemp+' --> Timeout (TBF), Sendefehler';
    2: ERRSTR[i]:='* Fehler'+stemp+' --> Timeout (RBF), Empfangsfehler';
    3: ERRSTR[i]:='* Fehler'+stemp+' --> Makroantwort nicht korrekt';
    4: dec(i);
    5: ERRSTR[i]:='* Fehler'+stemp+' --> Timeout (TBF), Unlocking nicht mglich ';
    6: ERRSTR[i]:='* Fehler'+stemp+' --> DLM konnte nicht zurckgesetzt werden';
    7: ERRSTR[i]:='* Fehler'+stemp+' --> DLM konnte nicht gesetzt werden';
    8: ERRSTR[i]:='* Fehler'+stemp+' --> DLP konnte nicht zurckgesetzt werden';
    9: ERRSTR[i]:='* Fehler'+stemp+' --> DLP konnte nicht gesetzt werden';
    10: ERRSTR[i]:='* Fehler'+stemp+' --> PC-DMA Time-Out';
    11: ERRSTR[i]:='* Fehler'+stemp+' --> TBF blieb nach Reset gesetzt';
    12: ERRSTR[i]:='* Fehler'+stemp+' --> DMA Transfer-Fehler';
    13: ERRSTR[i]:='* Fehler'+stemp+' --> DLP bei Normal-Read';
    else  ERRSTR[i]:='* Fehler'+stemp+' --> Unbekannter Fehler';
    end;
    inc(i);
    str(al:3,stemp);
    ERRSTR[i]:='* aufgetreten in Treiberfunktion '+stemp;
    inc(i);
    if al in [32,33,34,38,39] then begin
      ERRSTR[i]:='* Betroffener Makrobefehl und 2. Makrobyte: '+
                 hex(bl)+'H  '+ hex(bh)+'H';
      inc(i);
    end;

    if ah <> 3 then begin
      ERRSTR[i]:='* Status der Schnittstelle bei Fehler: ';
      if cl and 1 >0 then ERRSTR[i]:=ERRSTR[i]+'TBF ';
      if cl and 128 >0 then ERRSTR[i]:=ERRSTR[i]+'RBF ';
      if cl and 2 >0 then ERRSTR[i]:=ERRSTR[i]+'DLM ';
      if cl and 64 >0 then ERRSTR[i]:=ERRSTR[i]+'DLP ';
      inc(i);
    end;
    if ah=3 then begin
      ERRSTR[i]:='* erwartetes Byte:  '+hex(dh)+'H   empfangenes Byte: '+hex(dl)+'H (siehe nchste Zeile)';
      inc(i);
      CASE DL OF
        1 : ERRSTR[i]:='* '+hex(dl)+'H: Befehl ist ungltig';
        2 : ERRSTR[i]:='* '+hex(dl)+'H: Befehl ist unvollstndig bertragen';
        3 : ERRSTR[i]:='* '+hex(dl)+'H: Fehler bei der Ausfhrung des Befehls';
        4 : ERRSTR[i]:='* '+hex(dl)+'H: Befehl ist noch nicht implementiert';
        5 : ERRSTR[i]:='* '+hex(dl)+'H: Hardware fr Makrobefehl nicht vorhanden';
        6 : ERRSTR[i]:='* '+hex(dl)+'H: Funktionseinheit bereits benutzt';
        7 : ERRSTR[i]:='* '+hex(dl)+'H: Die anfragende Schnittstelle ist nicht Host';
        8 : ERRSTR[i]:='* '+hex(dl)+'H: Kein Zeichen an der seriellen Schnittstelle empfangen';
        9 : ERRSTR[i]:='* '+hex(dl)+'H: Die serielle Schnittstelle ist im Host-Mode';
        10: ERRSTR[i]:='* '+hex(dl)+'H: Downloadversuch ohne ausreichende Lizensierung';
      ELSE  ERRSTR[i]:='* '+hex(dl)+'H  ist kein MODULAR-4 - Fehlercode';
      END;
      inc(i);
    end;
    str(si:5,stemp);
    if ah=1 then begin
      ERRSTR[i]:='* Anzahl noch zu sendender Byte: '+stemp;
      inc(i);
    end;
    if (ah=2) or (ah=3) then begin
      ERRSTR[i]:='* Anzahl noch zu empfangender Byte: '+stemp;
      inc(i);
    end;

    str(ML4_get_var(37),stemp);
    ERRSTR[i]:='* Marke: '+stemp;
    inc(i);

    ERRSTR[i]:='*****************************************************************************';
    for j:=1 to i do BEGIN
      ERRSTR[j][0]:=#75;
      ERRSTR[j][75]:='*';
    END;
    GOTOXY(1,16);
    for j:=1 to i do writeln(ERRSTR[j]);
  end;

  repeat until keypressed;
  c:=readkey;
  if c=#27 then halt;
  if upcase(c)<>'N' then b:=ML4_CLEAR;
end;

{$F-}

(****************************************************************************
*     Prfen, ob Programm berhaupt auf der MODULAR-4 installiert ist       *
 ****************************************************************************)
function exist_prog(tsk:byte; var pgm:byte) : boolean;
var merk_pgm:byte;
    s:string;
begin
  merk_pgm:=pgm;
  pgm:=ml4_get_pgm_installed(tsk);
  if pgm=0 then begin
    exist_prog:=false;
    str(merk_pgm:3,stemp); str(tsk:3,stemp1);
    log('Achtung !  Programm '+stemp+' ist nicht unter der Task '+
         stemp1+' installiert.');
  end else begin
    exist_prog:=true;
  end;
end;
(****************************************************************************)



(****************************************************************************
*       Start eines 3964R - Programms auf der MODULAR-4                     *
*****************************************************************************)
procedure Starte_Maschine(Nr:integer);
begin
  if (Nr>7) or (Nr<0) then begin
     log('Maschine nicht implementiert.'); ch:=readkey;
     exit;
   end;
  with KanalRec[Nr] do begin
    if exist_prog(task,pgm) then begin
      pgmok:=true;
      if (ml4_get_par_byte(task,0)=0) then begin
        ml4_call_proc(task,6);             {Task initialisieren}
        ml4_set_par_byte(task,0,2);    {Task enablen}
      end else begin
        str(task:3,stemp);
        log('Task '+stemp+' ist bereits aktiv.');
      end;
    end else begin
      str(task:3,stemp);
      log('Task '+stemp+' ist nicht installiert.');
    end;
  end;
end;
(***************************************************************************)

(****************************************************************************
*       Abschalten eines 3964R - Programms auf der MODULAR-4                     *
*****************************************************************************)
procedure Stoppe_Maschine(Nr:integer);
begin
  if (Nr>7) or (Nr<0) then begin
     str(nr:3,stemp);
     log('Maschine '+stemp+' nicht implementiert.'); ch:=readkey;
     exit;
   end;
  with KanalRec[Nr] do begin
    if exist_prog(task,pgm) then begin
      ml4_set_par_byte(task,0,0);    {Task disablen}
    end else begin
      str(task:3,stemp);
      log('Task '+stemp+' ist nicht installiert.');
    end;
  end;
end;
(***************************************************************************)

(****************************************************************************
 *                     Sendereaktionstelegramm ablegen                              *
 ****************************************************************************)
procedure LogSendeReaktionsTelegramm(Maschine : byte);
var Offset : integer;
    Telegrammlaenge : byte;
    Telegramm : string;
begin
  with KanalRec[Maschine] do begin
    Offset:=ml4_get_par_word(task,35);
    ml4_set_dat_pointer(task,offset);
    Telegrammlaenge:=ml4_get_par_byte(task,PAR_NR_SRP_LG);
    ml4_task_block_read(task,Telegrammlaenge,puffer);
    move(puffer,Telegramm[1],Telegrammlaenge);
    Telegramm[0]:=char(Telegrammlaenge);
    str(Maschine:3,stemp);
    log('  Sendereaktionstelegramm vollstndig angekommen bei Maschine'+stemp+' : "'+Telegramm+'"');
  end;
end;

(****************************************************************************
 *                           Telegramm ablegen                              *
 ****************************************************************************)
procedure LogTelegramm(Maschine : byte);
var Offset : integer;
    Telegrammlaenge : byte;
    Telegramm : string;
begin
  with KanalRec[Maschine] do begin
    Offset:=ml4_get_par_word(task,37);
    ml4_set_dat_pointer(task,offset);
    Telegrammlaenge:=ml4_get_par_byte(task,PAR_NR_EP_LG);
    ml4_task_block_read(task,Telegrammlaenge,puffer);
    move(puffer,Telegramm[1],Telegrammlaenge);
    Telegramm[0]:=char(Telegrammlaenge);
    str(Maschine:3,stemp);
    log('  Telegramm vollstndig angekommen bei Maschine'+stemp+': "'+Telegramm+'"');
  end;
end;
(****************************************************************************)

(****************************************************************************
 *                SendeReaktionstelegramm senden                               *
 ****************************************************************************)
procedure SendeReaktionstelegramm(Maschine : byte; Telegramm: string);
var i: integer;
    Offset : integer;
    Empfangsstatus : byte;
begin
  with KanalRec[Maschine] do begin
    Offset:=ml4_get_par_word(task,39);
    ml4_set_dat_pointer(task,offset);
    Empfangsstatus:=ml4_get_par_byte(task,Par_Nr_ESTATUS);
    if (length(Telegramm)=0) then begin
      str(Empfangsstatus,stemp);
      log('  Empfangsstatus: '+stemp);
      log('  Telegrammlnge=0');
      exit;
    end;
    if (Empfangsstatus=2) then begin
      move(Telegramm[1],puffer,length(Telegramm));
      ml4_task_block_write(task,length(Telegramm),puffer);
      ml4_set_par_byte(task,PAR_NR_ERP_LG,length(Telegramm));
      ml4_set_par_byte(task,PAR_NR_ESTATUS,3);
      str(Maschine:3,stemp);
      log('  ReaktionsTelegramm von Maschine'+stemp+' gesendet: "'+Telegramm+'"');
    end else begin
      str(Empfangsstatus,stemp);
      log('  Empfangsstatus: '+stemp);
      log('  ReaktionsTelegramm-Puffer noch besetzt');
      exit;
    end;
  end;
end;

(****************************************************************************
 *                           Telegramm senden                               *
 ****************************************************************************)
procedure SendeTelegramm(Maschine : byte; Telegramm: string);
var i: integer;
    Offset : integer;
    Sendestatus : byte;
begin
  log('');
  with KanalRec[Maschine] do begin
    Offset:=ml4_get_par_word(task,33);
    ml4_set_dat_pointer(task,offset);
    Sendestatus:=ml4_get_par_byte(task,Par_Nr_SSTATUS);
    if (length(Telegramm)=0) then begin
      str(Sendestatus,stemp);
      log('  Sendestatus: '+stemp);
      log('  Telegrammlnge=0');
      exit;
    end;
    if (Sendestatus in [0,3,4,5]) then begin
      move(Telegramm[1],puffer,length(Telegramm));
      ml4_task_block_write(task,length(Telegramm),puffer);
      ml4_set_par_byte(task,PAR_NR_SP_LG,length(Telegramm));
      ml4_set_par_byte(task,PAR_NR_SSTATUS,1);
      str(Maschine:3,stemp);
      log('  Telegramm von Maschine'+stemp+' gesendet: "'+Telegramm+'"');
    end else begin
      str(Sendestatus,stemp);
      log('  Sendestatus: '+stemp);
      log('  Telegramm-Puffer noch nicht frei');
      exit;
    end;
  end;
end;
(****************************************************************************)

(****************************************************************************
 *                        Telegrammverarbeitung                             *
 ****************************************************************************)
procedure Telegrammverarbeitung(var Maschine: byte);
var b: byte;
begin
  str(Maschine:2,stemp); str(sstatus:1,stemp1); str(estatus:1,stemp2);
  log('--> Telegrammverarbeitung Maschine'+stemp+'    Sendestatus: '+stemp1+
       '    Empfangsstatus: '+stemp2);
  with kanalrec[maschine] do begin
    if SSTATUS>0 then begin
      case SSTATUS of
        0: ;  {Sendebereit}
        1:;{Kommando}
        2: log('  Sendung luft');
        3: log('  Telegramm komplett gesendet, Sendung beendet');
        4: begin
            log('  Reaktionstelegramm vollstndig empfangen');
            LogSendeReaktionsTelegramm(Maschine);
           end;
        5: begin
             str(sstatus:1,stemp); str(serrph:2,stemp1);
             ml4_set_par_byte(task,par_nr_sstatus,0);
             log('  Sendestatus '+stemp+' Fehler: '+bit(serr)+' Sendefehlerphase: '+stemp1);
             if (serr and 1)>0 then log('    Bit 0: Timeout durch QVZ');
             if (serr and 2)>0 then log('    Bit 1: Timeout durch ZVZ');
             if (serr and 4)>0 then log('    Bit 2: max. Telegrammlnge berschritten');
             if (serr and 8)>0 then log('    Bit 3: BCC Prfzeichenfehler');
             if (serr and 16)>0 then log('    Bit 4: Parity- oder Overrun-Fehler');
             if (serr and 32)>0 then log('    Bit 5: Telegramm-Overrun');
             if (serr and 64)>0 then BEGIN
               b:=ml4_get_par_byte(task,71); {unerwartetes Zeichen}
               if b=21 then stemp2:='NAK' else  str(b:3,stemp2);
               case serrph of
               0: log('    Bit 6: Telegrammlnge ist 0');

               2: log('    Bit 6: weder DLE noch STX empfangen, sondern '+
                        'ASCII: '+stemp2);
               6: log('    Bit 6: kein DLE empfangen, sondern '+
                        'ASCII: '+stemp2);

               10: log('    Bit 6: kein STX empfangen, sondern '+
                        'ASCII: '+stemp2);
               else
                 log('    Bit 6: sonstiger Fehler (s.Fehlertabelle)');
               end;
             END;
             if (serr and 128)>0 then log('    Bit 7: beim Empfang des Reaktionstelegramms')
                                 else log('    Bit 7: beim Senden des Telegramms');
           end;
      else
      end;
    end;
    if ESTATUS>0 then begin
      case ESTATUS of
        0: ;  {Empfangsbereit}
        1: log('  Empfang luft');
        2: begin  {Telegramm vollstndig angekommen}
             if not autoreak then begin
               logtelegramm(Maschine);
               if REAKTELE=1 then begin
                 SendeReaktionstelegramm(Maschine,#0+#0+#0+#0);
               end else begin
                 ml4_set_par_byte(task,par_nr_estatus,0);
               end;
	     end else log('  Telegramm angekommen');
           end;
        3:; {Kommando}
        4: begin
             log('  Reaktionstelegramm gesendet');
           end;
        5: begin
             log('  Reaktionstelegramm vollstndig bei Gegenseite angekommen');
             if autoreak then logtelegramm(Maschine);
             ml4_set_par_byte(task,par_nr_estatus,0);
           end;
        6: begin
            ml4_set_par_byte(task,par_nr_estatus,0);
            str(estatus:1,stemp); str(eerrph:2,stemp1);
            log('  Empfangsstatus '+stemp+' Fehler: '+bit(eerr)+' Empfangsfehlerphase: '+stemp1);
            if (eerr and 1)>0 then log('    Bit 0: Timeout durch QVZ');
            if (eerr and 2)>0 then log('    Bit 1: Timeout durch ZVZ');
            if (eerr and 4)>0 then log('    Bit 2: max. Telegrammlnge berschritten');
            if (eerr and 8)>0 then log('    Bit 3: BCC Prfzeichenfehler');
            if (eerr and 16)>0 then log('    Bit 4: Parity- oder Overrun-Fehler');
            if (eerr and 32)>0 then log('    Bit 5: Telegramm-Overrun');
            if (eerr and 64)>0 then log('    Bit 6: sonstiger Fehler (s.Fehlertabelle)');
            if (eerr and 128)>0 then log('    Bit 7: beim Empfang des Telegramms')
                                else log('    Bit 7: beim Senden des Reaktionstelegramms')         end;

      else
      end;
    end;
  end;
end;
(****************************************************************************)

(****************************************************************************
 *                Auslesen und Anzeige Status/Fehler-Parameter              *
 ****************************************************************************)
procedure Maschinenstatus(Maschine : byte);
var tsk : byte;
    i   : word;
begin
  tsk:=KanalRec[maschine].task;
  i:=10;
  ml4_set_mark(i);inc(i);
  SSTATUS:=ml4_get_par_byte(tsk,PAR_NR_SSTATUS);
  SSTATUS:=ml4_get_par_byte(tsk,PAR_NR_SSTATUS);
  SERR:=ml4_get_par_byte(tsk,PAR_NR_SERR);
  SP_LG:=ml4_get_par_byte(tsk,PAR_NR_SP_LG);
  SRP_LG:=ml4_get_par_byte(tsk,PAR_NR_SRP_LG);
  SPHASE:=ml4_get_par_byte(tsk,PAR_NR_SPHASE);
  SERRPH:=ml4_get_par_byte(tsk,PAR_NR_SERRPH);
  ESTATUS:=ml4_get_par_byte(tsk,PAR_NR_ESTATUS);
  EERR:=ml4_get_par_byte(tsk,PAR_NR_EERR);
  EP_LG:=ml4_get_par_byte(tsk,PAR_NR_EP_LG);
  ERP_LG:=ml4_get_par_byte(tsk,PAR_NR_ERP_LG);
  EPHASE:=ml4_get_par_byte(tsk,PAR_NR_EPHASE);
  EERRPH:=ml4_get_par_byte(tsk,PAR_NR_EERRPH);
  REAKTELE:=ml4_get_par_byte(tsk,PAR_NR_REAKTELE);
  ml4_set_mark(i);inc(i);

  gotoxy(1+(maschine*20),1); write('SSTATUS  ',SSTATUS:4);
  gotoxy(1+(maschine*20),2); write('SERR     ',bit(SERR));
  gotoxy(1+(maschine*20),3); write('SP_LG    ',SP_LG:4);
  gotoxy(1+(maschine*20),4); write('SRP_LG   ',SRP_LG:4);
  gotoxy(1+(maschine*20),5); write('SPHASE   ',SPHASE:4);
  gotoxy(1+(maschine*20),6); write('SERRPH   ',SERRPH:4);
  gotoxy(1+(maschine*20),7); write('ESTATUS  ',ESTATUS:4);
  gotoxy(1+(maschine*20),8); write('EERR     ',bit(EERR));
  gotoxy(1+(maschine*20),9); write('EP_LG    ',EP_LG:4);
  gotoxy(1+(maschine*20),10); write('ERP_LG   ',ERP_LG:4);
  gotoxy(1+(maschine*20),11); write('EPHASE   ',EPHASE:4);
  gotoxy(1+(maschine*20),12); write('EERRPH   ',EERRPH:4);
  gotoxy(1+(maschine*20),13); write('REAKTELE ',REAKTELE:4);

  gotoxy(1+(maschine*20),14); write('Maschine ',Maschine:4);
end;
(****************************************************************************)


(****************************************************************************
 *                    Start des Programms DF                                *
 ****************************************************************************)
procedure CounterStarten;
type t_timer_task = record
                      task     : byte;
                      descript : string[20];
                    end;
const
  timertask : array [1..4] of t_timer_task = ((task: 2;
                                               descript: 'Timer A'),
                                               (task: 7;
                                               descript: 'Timer B'),
                                               (task: $A;
                                               descript: 'Timer C'),
                                               (task: $B;
                                               descript: 'Timer D'));
var pgm : byte;
    i   : integer;
begin
  pgm:=$DF;
  for i:=1 to 4 do begin
    with timertask[i] do begin
      if ml4_get_pgm_installed(task)>0 then begin  {Timertask gefunden}
        log(descript+' wird fr Timeoutprfungen verwendet.');
        if (ml4_get_par_byte(task,0)=0) then begin
          ml4_call_proc(task,6);
          log('Task '+hex(task)+'H gestartet.');
        end else log('Task '+hex(task)+'H ist bereits aktiv.');
        exit; 
      end;
    end;
  end;
end;
(****************************************************************************)


(****************************************************************************
 *                    Initialisierung diverser Variablen                    *
 ****************************************************************************)
procedure init;
var i : integer;
    i_task,i_pgm : byte;
begin
  i_task:=$D0; i_pgm:=$D0;
  for i:=0 to 7 do begin
    with KanalRec[i] do begin
      SP:=''; SRP:=''; EP:=''; ERP:='';
      task:=i_Task; inc(i_task);
      pgm:=i_pgm; inc(i_pgm);
      Arbeit:=false;
      pgmok:=false;
    end;
  end;
end;
(****************************************************************************)


var task      : byte;
    Maschine  : byte;
    w         : word;
    letzter_Kanal : integer;
    initerror : word;
(****************************Hauptprogramm***********************************)
begin
  clrscr;

  ml4_set_var(1,500); {Base-Delay}

  Initerror:=ml4_init($380,1,7,0);
  if initerror>0 then begin
    writeln('Kommunikation zur MODULAR-4 Karte konnte nicht hergestellt werden.');
    writeln('Initerror: ',initerror);
    exit;
  end;

  ml4_set_service(@intproc);
  ml4_set_error_handling(@MY_recovery);

  init;

  assign(logfile,'log.dat');
  rewrite(logfile);
(*
  ml4_set_par_byte($D0,0,0);      {Disable Task}
  ml4_set_par_byte($D1,0,0);      {Disable Task}
*)

  CounterStarten;
  letzter_Kanal:=-1;
  Starte_Maschine(0);

  if KanalRec[0].pgmok then begin
    letzter_Kanal:=0;

    ml4_set_par_byte($D0,4,55);      {Beispiel fr Setzen von  QVZ}
    ml4_set_par_byte($D0,5,22);                               {ZVZ}
    ml4_set_par_byte($D0,6,10);                               {RVZ}

    ml4_set_par_byte($D0,7,3);       {Senderetry setzen}

    ml4_set_par_byte($D0,PAR_NR_REAKTELE,1);  {0 = ohne Reaktionstelegramm}
                                              {1 = mit}

    ml4_set_par_byte($D0,PAR_NR_IRGEN,$FF);  {PC-Interruptgenerierung}

    ml4_set_par_byte($D0,PAR_NR_DOMINANZ,1); {keine Dominanz fr den Kanal}

    Maschinenstatus(0);

  end;

  Starte_Maschine(1);

  if KanalRec[1].pgmok then begin
    letzter_Kanal:=1;

    ml4_set_par_byte($D1,4,100);
    ml4_set_par_byte($D1,5,22);
    ml4_set_par_byte($D1,6,0);

    ml4_set_par_byte($D1,7,3);       {Senderetry setzen}

    ml4_set_par_byte($D1,PAR_NR_REAKTELE,1);  {0 = ohne Reaktionstelegramm}
                                              {1 = mit}
    ml4_set_par_byte($D1,PAR_NR_IRGEN,$FF);

    ml4_set_par_byte($D1,PAR_NR_DOMINANZ,0);  {Dominanz fr den Kanal}

    Maschinenstatus(1);
  end;


  ch:=' '; Stepmodus:=false; Dauertest:=false; autoreak:=false;

  gotoxy(1,25); clreol;
  write('Es liegen keine Interrupt-Anforderungen vor. Abbruch mit ESC');
  log('');
  if letzter_Kanal<0 then begin
    writeln('Es ist kein 3964/R-Protokoll installiert.');
    exit;
  end;
  repeat
    ml4_set_mark(1);
    for Maschine:=0 to letzter_Kanal do begin    {bis max. 7}
      with kanalrec[Maschine] do begin
        if Arbeit then begin
          Arbeit:=false;   {Interrupt-Merker zurcksetzen}
          sound(1500);delay(100); nosound;
          if Stepmodus then begin
            gotoxy(1,25); clreol;
            Write('Interrupt-Anforderung fr Maschine ',Maschine,' --> Taste drcken');
            ch:=readkey;
          end;
          Maschinenstatus(Maschine);
          ml4_set_mark(2);
          Telegrammverarbeitung(Maschine);
          ml4_set_mark(3);
          Maschinenstatus(Maschine);
          ml4_set_mark(4);
        end;
      end;
      gotoxy(1,25); clreol;
      write('Es liegen keine Interrupt-Anforderungen vor. Abbruch mit ESC');
    end;

    if keypressed then begin
      ch:=readkey;
      if ch=#0 then begin  {Funktionstaste}
        ch:=readkey;
        case ch of
	  F1 : SendeTelegramm(0,#0+#0+#0+#0+#0+#0+#0+#0+#0+#0+#0+#4+'ABCD');
          F2 : SendeTelegramm(1,#0+#0+#0+#0+#0+#0+#0+#0+#0+#0+#0+#4+'1234');
          F3 : begin {Automatisches Reaktionstelegramm anschalten}
                autoreak:=true;
	    	ml4_set_par_byte($D0,PAR_NR_REAKTELE,2);  {Auto Rektionstele}
		ml4_set_par_byte($D0,PAR_NR_IRGEN,$EF);
	    	ml4_set_par_byte($D1,PAR_NR_REAKTELE,2);
		ml4_set_par_byte($D1,PAR_NR_IRGEN,$EF);
               end;
          F4 : begin {Automatisches Reaktionstelegramm abschalten}
                autoreak:=false;
	    	ml4_set_par_byte($D0,PAR_NR_REAKTELE,1);  {Normal Rektionstele}
		ml4_set_par_byte($D0,PAR_NR_IRGEN,$FF);
	    	ml4_set_par_byte($D1,PAR_NR_REAKTELE,1);
		ml4_set_par_byte($D1,PAR_NR_IRGEN,$FF);
               end;
          F8 : if Dauertest then Dauertest:=false else Dauertest:=true;
          F9 : if Stepmodus then Stepmodus:=false else Stepmodus:=true;
        else
        end;
      end;
    end else begin
      if Dauertest then begin
        if ml4_get_par_byte($D0,Par_Nr_SSTATUS) in [0,3,4] then begin
          SendeTelegramm(0,#0+#0+#0+#0+#0+#0+#0+#0+#0+#0+#0+#4+'ABCD');
        end;
      end;
    end;
  until ch=#27;

  Stoppe_Maschine(0);
  Stoppe_Maschine(1);
  ml4_exit;
  close(logfile);
  clrscr;
end.