{$B+,D-,F-,I+,L-,N-,R-,S-,V-}

(*

   B I B L I O T H E K   M L 4 B I B

   Kommunikation PC <->  MODUAR-4, Grundeinheit

   Makrobefehle fr das Betriebssystem der MODULAR-4 Karte

   von SORCUS COMPUTER GmbH

   Dateiname: ML4BIB.PAS

   Version 1.H.

   Bibliothek als Unit fr Turbo Pascal 4.0, 5.0, 5.5 und 6.0

   nderungen vorbehalten

   Status: freigegeben

*)

(* Letzte Bearbeitung :   05-09-91  *)


UNIT ML4BIB;  {"ML4BIB" soll heien ModuLar-4 BIBliothek}

INTERFACE

USES  crt, dos;

const
  softint : word = $62;

TYPE
  ml4_error_info_type =
  record
    ok           : boolean;
    func,
    code,
    first_byte,
    second_byte,
    status,
    received,
    expected     : byte;
    missing,
    mark         : word;
  end;

Var
  ml4_error_info : ml4_error_info_type;


(********   Initialisierungs-Prozeduren ************)

PROCEDURE ml4_select_card(card : BYTE);
FUNCTION  ml4_init (adr, mode, IRQ_channel, DMA_channel : WORD) : BYTE;
PROCEDURE ml4_set_service (ml4_servProc : POINTER);
PROCEDURE ml4_set_error_handling(error_handling_proc : POINTER);
PROCEDURE ml4_error_handling;
PROCEDURE ml4_get_error_info(var err_rec : ml4_error_info_type);
FUNCTION  ml4_reacting : BOOLEAN;
FUNCTION  ml4_clear : BYTE;
FUNCTION  ml4_hard_reset : BYTE;
PROCEDURE ml4_set_dma_mode(mode,request_byte:BYTE);
PROCEDURE ml4_exit;
(*****************************************************)


(****** Prozeduren fr das Treiber-Handling  *********)

FUNCTION  ml4_message_available : BOOLEAN;
FUNCTION  ml4_get_message : BYTE;
FUNCTION  ml4_get_var(number : BYTE) : WORD;    {read/write oder get/set}
PROCEDURE ml4_set_var(number : BYTE; value : WORD);
PROCEDURE ml4_set_mark(mark : WORD);


(******   Makro-Implementations-Prozeduren  *********)

PROCEDURE ml4_write (b : BYTE);   {ohne unlock}
FUNCTION  ml4_read : BYTE;
PROCEDURE ml4_lock;
PROCEDURE ml4_unlock;
PROCEDURE macro_0(inp : POINTER; inplg :WORD);
PROCEDURE macro_1(inp : POINTER; inplg:WORD;
                  outp : POINTER; outlg :WORD);
PROCEDURE macro_2(INP : POINTER; inplg :WORD;
                  outp : POINTER; outlg :WORD);
PROCEDURE ml4_macro_end;
(*****************************************************)


(******   Diverse Makro-Befehle fr das Betriebssystem  *********)
FUNCTION  ml4_system_call(nr,par : WORD) : WORD;

FUNCTION  ml4_rom_pgm(pgm : BYTE) : BYTE;

PROCEDURE ml4_set_ram_pointer(adr : WORD);

PROCEDURE ml4_start_pgm;

FUNCTION  ml4_get_ram : BYTE;
PROCEDURE ml4_put_ram(data : BYTE);

FUNCTION  ml4_in_port(port : BYTE) : BYTE;
PROCEDURE ml4_out_port(port,data : BYTE);

(*****************************************************)


(******   Taskorientierte Makro-Implementationen ohne Taskvorwahl *********)

PROCEDURE ml4_install_rom_task(task,pgm : BYTE;datasize : WORD);
PROCEDURE ml4_install_ram_task(task : BYTE;adr,datasize : WORD);

PROCEDURE ml4_concat_task(task1,task2 : BYTE);

PROCEDURE ml4_sleep_task(task : BYTE);

PROCEDURE ml4_wakeup_task(task : BYTE);

FUNCTION ml4_get_active_task(task : BYTE) : BYTE;

FUNCTION  ml4_get_pgm_installed(task : BYTE) : BYTE;

PROCEDURE ml4_set_dat_pointer(task : BYTE;adr : WORD);

FUNCTION  ml4_get_dat_byte(task : BYTE) : BYTE;
PROCEDURE ml4_set_dat_byte(task, data : BYTE);

FUNCTION  ml4_get_dat_word(task : BYTE) : WORD;
PROCEDURE ml4_set_dat_word(task : BYTE;data : WORD);

FUNCTION  ml4_get_par_byte(task, parameter : BYTE) : BYTE;
PROCEDURE ml4_set_par_byte(task, parameter, value : BYTE);

FUNCTION  ml4_get_par_word(task, parameter : BYTE) : WORD;
PROCEDURE ml4_set_par_word(task, parameter : BYTE; value : WORD);

PROCEDURE ml4_call_proc(task, proc : byte);

PROCEDURE ml4_task_block_read(task : BYTE; blocksize : WORD; VAR data);
PROCEDURE ml4_task_block_write(task : BYTE; blocksize : WORD; VAR data);

{----------------------------------------------------------------------}

IMPLEMENTATION

VAR savesoftint,                {ursprnglicher Softintvektor}
    Exitsave       : pointer;	{Pointer auf Original-Exitroutine}
    savehardint    : array [0..7] of pointer;  {ursprnglicher Hardintvektor}
    hardintused    : array [0..7] of boolean;
    regs           : registers; {Register-Record}

CONST

   Karte : word = 0;

{---------------------------------------------------------------------------}
procedure ISR_TAB; external;
procedure FUNK000; external;
procedure FUNK001; external;
procedure FUNK002; external;
procedure FUNK003; external;
procedure FUNK004; external;
procedure FUNK005; external;
procedure FUNK006; external;
procedure FUNK007; external;
procedure FUNK008; external;
procedure FUNK009; external;
procedure FUNK010; external;

procedure FUNK016; external;
procedure FUNK017; external;
procedure FUNK018; external;
procedure FUNK019; external;
procedure FUNK020; external;
procedure FUNK021; external;

procedure FUNK038; external;
procedure FUNK039; external;
procedure FUNK040; external;
procedure FUNK041; external;

procedure FUNK032; external;
procedure FUNK033; external;
procedure FUNK034; external;

{$L ML4DRIV.OBJ}


var
      errcode : BYTE;


(**********************   Fehlerbehandlungs - Prozeduren ********************)


FUNCTION Hex(DEZ:integer):string; {Hilfsfunktion fr Hexadezimale Ausgabe}
VAR s   : string;
    i,a : integer;
const stellen = #2;
BEGIN
  s[0]:=stellen;
  FOR i:=ord(stellen) downto 1 do BEGIN
    a:=dez mod 16;
    dez:=dez div 16;
    IF a<10 then s[i]:=char(ord('0')+ ord(a))
            ELSE s[i]:=char(ord('A')+ ord(a)-10);
  END;
  s[0]:=stellen;
  hex:=s;
END;

function bit(b:byte) : string;
var j,itemp : integer;
    s : string;
begin
  s[0]:=#8; itemp:=b;
  for j:=1 to 8 do begin
    if itemp and 128 > 0 then s[j]:='1' else s[j]:='0';;
    itemp:=itemp shl 1;
  end;
  bit:=s;
end;



(*************************************************************************)



(********   Initialisierungs-Prozeduren ************)

PROCEDURE ml4_select_card(card : BYTE); {Kartenanwahl}
BEGIN
  Karte:=CARD;
  FUNK009; {Karte in AL}
END;



FUNCTION ml4_init (adr, Mode, IRQ_channel, DMA_channel : word) : BYTE;
var
    p          : ^word;

BEGIN
  if mode and 1 = 1 then begin {Hard-Interrupt-Vektor setzen}
    hardintused[IRQ_channel]:=true;
    getintvec(IRQ_channel+8,savehardint[IRQ_channel]);
    p:=@isr_tab;
    p:= ptr(cseg,ofs(p^)+(Karte*2));
    setintvec(IRQ_channel+8,ptr(cseg,p^));
  end;
  regs.ah:=1;   {Funktion: Initialisieren der Schnittstelle}
  regs.al := Mode; {Betriebsart}
  regs.cx := adr;
  regs.dl := IRQ_channel; {oder serieller Kanal}
  regs.dh := DMA_channel;
  intr(softint,regs);
  ml4_init:=regs.ah;
  ml4_set_error_handling(@ml4_error_handling);  {Fehlerbehandlungs-Prozedur}
                                                {zuweisen}
END;



PROCEDURE ml4_set_service (ml4_servProc : pointer);
BEGIN
  with regs do begin
    ah:=3;
    DX:=WORD(PTR(SEG(ml4_servProc),OFS(ml4_servProc))^);
    ES:=WORD(PTR(SEG(ml4_servProc),OFS(ml4_servProc)+2)^);
    DS := dseg;
    intr(softint,regs);
  end;

END;


PROCEDURE ml4_set_error_handling(error_handling_proc : POINTER);
BEGIN
  with regs do begin
    ah:=2;
    DX:=WORD(PTR(SEG(error_handling_proc),OFS(error_handling_proc))^);
    ES:=WORD(PTR(SEG(error_handling_proc),OFS(error_handling_proc)+2)^);
    DS := dseg;
    intr(softint,regs);
  end;
END;


{$F+}

PROCEDURE ml4_error_handling;
var c         : char;
    ERRSTR    : ARRAY [1..10] OF STRING;
    stemp     : string; {Hilfsstring}
    code7bit  : byte;
    i,j       : INTEGER;
begin
  ml4_get_error_info(ml4_error_info);
  if ml4_error_info.ok then exit;   {kein Fehler aufgetreten}
  FILLCHAR(ERRSTR,sizeof(errstr),' ');
  with ml4_error_info do begin
    I:=1;
    ERRSTR[i]:='************ Fehlermeldung des PC - MODULAR-4 Treibers *****************************';
    inc(i);
    if code and 128 = 128 then begin
      ERRSTR[i]:='* Kommunikationsversuch nach Fehler ohne Reinitalisierung';
      inc(i);
      code7bit:=code and 127;
    end else code7bit:=code;
    str(code7bit:3,stemp);
    case code7bit of
    1: ERRSTR[i]:='* Fehler'+stemp+' --> Timeout (TBF), Sendefehler';
    2: ERRSTR[i]:='* Fehler'+stemp+' --> Timeout (RBF), Empfangsfehler';
    3: ERRSTR[i]:='* Fehler'+stemp+' --> Makroantwort nicht korrekt';
    4: dec(i);
    5: ERRSTR[i]:='* Fehler'+stemp+' --> Timeout (TBF), Unlocking nicht mglich ';
    6: ERRSTR[i]:='* Fehler'+stemp+' --> DLM konnte nicht zurckgesetzt werden';
    7: ERRSTR[i]:='* Fehler'+stemp+' --> DLM konnte nicht gesetzt werden';
    8: ERRSTR[i]:='* Fehler'+stemp+' --> DLP konnte nicht zurckgesetzt werden';
    9: ERRSTR[i]:='* Fehler'+stemp+' --> DLP konnte nicht gesetzt werden';
    10: ERRSTR[i]:='* Fehler'+stemp+' --> PC-DMA Time-Out';
    11: ERRSTR[i]:='* Fehler'+stemp+' --> TBF blieb nach Reset gesetzt';
    12: ERRSTR[i]:='* Fehler'+stemp+' --> DMA Transfer-Fehler';
    13: ERRSTR[i]:='* Fehler'+stemp+' --> DLP bei Normal-Read';
    else  ERRSTR[i]:='* Fehler'+stemp+' --> Unbekannter Fehler';
    end;
    inc(i);
    str(func:3,stemp);
    ERRSTR[i]:='* aufgetreten in Treiberfunktion '+stemp;
    inc(i);
    if func in [32,33,34,38,39] then begin
      ERRSTR[i]:='* Betroffener Makrobefehl und 2. Makrobyte: '+
                 hex(first_byte)+'H  '+ hex(second_byte)+'H';
      inc(i);
    end;

    if code7bit <> 3 then begin
      ERRSTR[i]:='* Status der Schnittstelle bei Fehler: ';
      if status and 1 >0 then ERRSTR[i]:=ERRSTR[i]+'TBF ';
      if status and 128 >0 then ERRSTR[i]:=ERRSTR[i]+'RBF ';
      if status and 2 >0 then ERRSTR[i]:=ERRSTR[i]+'DLM ';
      if status and 64 >0 then ERRSTR[i]:=ERRSTR[i]+'DLP ';
      inc(i);
    end;
    if code7bit=3 then begin
      ERRSTR[i]:='* erwartetes Byte:  '+hex(expected)+'H   empfangenes Byte: '+
                                      hex(received)+'H (siehe nchste Zeile)';
      inc(i);
      CASE received OF
        1 : ERRSTR[i]:='* '+hex(received)+'H: Befehl ist ungltig';
        2 : ERRSTR[i]:='* '+hex(received)+'H: Befehl ist unvollstndig bertragen';
        3 : ERRSTR[i]:='* '+hex(received)+'H: Fehler bei der Ausfhrung des Befehls';
        4 : ERRSTR[i]:='* '+hex(received)+'H: Befehl ist noch nicht implementiert';
        5 : ERRSTR[i]:='* '+hex(received)+'H: Hardware fr Makrobefehl nicht vorhanden';
        6 : ERRSTR[i]:='* '+hex(received)+'H: Funktionseinheit bereits benutzt';
        7 : ERRSTR[i]:='* '+hex(received)+'H: Die anfragende Schnittstelle ist nicht Host';
        8 : ERRSTR[i]:='* '+hex(received)+'H: Kein Zeichen an der seriellen Schnittstelle empfangen';
        9 : ERRSTR[i]:='* '+hex(received)+'H: Die serielle Schnittstelle ist im Host-Mode';
        10: ERRSTR[i]:='* '+hex(received)+'H: Downloadversuch ohne ausreichende Lizensierung';
      ELSE  ERRSTR[i]:='* '+hex(received)+'H  ist kein MODULAR-4 - Fehlercode';
      END;
      inc(i);
    end;
    if code7bit in [1,2] then begin
      str(missing:5,stemp);
      if code7bit=1
      then ERRSTR[i]:='* Anzahl noch zu sendender Byte: '+stemp
      else ERRSTR[i]:='* Anzahl noch zu empfangender Byte: '+stemp;
      inc(i);
    end;

    str(mark,stemp);
    ERRSTR[i]:='* Marke: '+stemp;
    inc(i);

  end;

  ERRSTR[i]:='* <S> = Stop   <ESC> = Weiter mit ml4_clear   <andere> = Weiter';
  inc(i);

  ERRSTR[i]:='*****************************************************************************';
  for j:=1 to i do BEGIN
    ERRSTR[j][0]:=#75;
    ERRSTR[j][75]:='*';
  END;

  DIRECTVIDEO:=TRUE;  {nur ntig bei Betrieb mit Interrupt}
  writeln;
  for j:=1 to i do writeln(ERRSTR[j]);

  repeat until keypressed;
  c:=readkey;
  if keypressed then   c:=readkey; {erweiterten Tastaturcode auslesen}
  c:=upcase(c);
  case c of
  'S': halt; {stop programm}
  #27: begin
	 IF ml4_clear>0 then begin
	   ml4_get_error_info(ml4_error_info); {Auswertung von ml4_error_info mglich}
	   writeln('Durch "ml4_clear" kann die Kommunikation zur MODULAR-4 Karte nicht');
           writeln(' wieder hergestellt werden! Das Programm wurde angehalten.');
           halt;
         end;
       end;
  else
    {nichts tun}
  end;
end;

{$F-}


PROCEDURE ml4_get_error_info(var err_rec : ml4_error_info_type);
BEGIN
  err_rec.ok:=boolean(lo(ml4_get_var(10)));
  if err_rec.ok then exit;
  with regs do begin
    ah:=18; {Statusmeldung}
    intr(softint,regs);
    with err_rec do begin
      func:=al;
      code:=ah;
      first_byte:=bl;
      second_byte:=bh;
      status:=cl;
      received:=dl;
      expected:=dh;
      missing:=si;
    end;
  end;
  err_rec.mark:=ml4_get_var(37);
END;



(* Reaktionstest der MODULAR-4 Karte *)
FUNCTION ml4_reacting: BOOLEAN;
var input  : byte;
    output : byte;
BEGIN
  input:=0;
  macro_1(@input,1,@output,1);
  if input=output then ml4_reacting:=true else ml4_reacting:=false;
END;



FUNCTION ml4_clear : BYTE;
begin
  FUNK006;
  inline($88/$66/$FF)  {MOV [BP-1],AH}
end;



FUNCTION ml4_hard_Reset : BYTE;
BEGIN
  FUNK007;
  inline($88/$66/$FF)  {MOV [BP-1],AH}
END;



PROCEDURE ml4_set_dma_mode(mode,request_byte:byte);
BEGIN
  inline($8A/$5E/<mode);     	{MOV BL,[BP+OFS8]}
  inline($8A/$7E/<request_byte);{MOV BH,[BP+OFS8]}
  FUNK010;
END;



{$F+} {mu in jedem Falle "far" kompiliert werden}
PROCEDURE ml4_exit;
var i,j : integer;
BEGIN

  for i:=0 to 7 do  begin
    ml4_select_card(i);  {Karte anwhlen}
                         {Luft DMA Blocktransfer noch ?}
    j:=0;
    while (lo(ml4_get_var(15)) and 7 > 0) and (j<10) do begin
      delay(100); {10 mal 100 ms warten}
      inc(j);
    end;
    FUNK008;	{Softint - Close/Exitfunktion, Funktion 008}
    if hardintused[i]=true then begin {Die Vektoren benutzter IRQ-Kanle restaurieren}
      setintvec(i+8,savehardint[i]);
      hardintused[i]:=false;
    end;
  end;
  setintvec(softint,savesoftint);
  exitproc:=exitsave;
END;
{$F-}
(***************************************************************************)




(****** Prozeduren fr das Treiber-Handling  *********)


FUNCTION  ml4_message_available : BOOLEAN;
var  w : word;
begin
  w:=ml4_get_var(15);
  if hi(w) and 64 = 64
    then ml4_message_available:=true
    else ml4_message_available:=false;
end;



FUNCTION ml4_get_message : BYTE;
begin
  FUNK017;
  INLINE($88/$46/$FF);   	{MOV [BP-1],AL}
end;



FUNCTION  ml4_get_var(number : byte) : word;
begin
  inline($8A/$46/<number); 	{MOV AL,[BP-ADR8]}
  FUNK005;
  inline($89/$56/<-2);		{MOV [BP-2],DX}
end;


PROCEDURE ml4_set_var(number : byte; value : word);
begin
  inline($8A/$46/<number);  	{MOV AL,[BP-ADR8]}
  inline($8B/$96/>value);   	{MOV DX,[BP-ADR16]}
  FUNK004;
end;



PROCEDURE ml4_set_mark(mark : word);
begin
  ml4_set_var(37,mark);
end;
(***************************************************************************)




(******   Makro-Implementations-Prozeduren  *********)


PROCEDURE ml4_write (b : BYTE);
BEGIN
		{AL mit b durch Prozeduraufruf schon geladen}
  FUNK040;      {ein Byte zur Modular-4 schreiben}
END;



FUNCTION ml4_read : BYTE;      {Ein BYTE von der MODULAR-4 lesen}
BEGIN
  FUNK041;
  inline($88/$46/$FF)  {MOV [BP-1],AL}
END;



PROCEDURE ml4_lock;
BEGIN
  FUNK019;
END;



PROCEDURE ml4_unlock;
BEGIN
  FUNK020;
END;


{---------------------------------------------------------------------------}
procedure macro_0(INP : POINTER; INPLG :WORD); external;

procedure macro_1(INP : POINTER; INPLG :WORD;
                 OUTP : POINTER; OUTLG :WORD); external;

procedure macro_2(INP : POINTER; INPLG :WORD;
                 OUTP : POINTER; OUTLG :WORD); external;
{$L ML4PIMP.OBJ}
{---------------------------------------------------------------------------}



PROCEDURE ml4_macro_end;
begin
  FUNK021;
end;
(***************************************************************************)




(******   Diverse Makro-Befehle fr das Betriebssystem  *********)


(* Systemcall aufrufen *)
FUNCTION ml4_system_call(nr,par : word) : word;
var input  : RECORD
               c,
               nr  : byte;
               par : word;
             end;
    output : record
               x : byte;
               w : word;
             end;
BEGIN
  input.c:=$17;
  input.nr:=lo(nr);
  input.par:=par;
  macro_1(@INPUT,4,@output,3);
  ml4_system_call:=output.w; { Funktionszuweisung }
END;


(* Setzen des Memorypointers *)
PROCEDURE ml4_set_ram_pointer(adr : WORD);
VAR input : record
              c    : byte;
              adr  : word;
            end;
BEGIN
  input.c:=$20;
  input.adr:=adr;
  macro_0(@INPUT,3);
END;


(* Programm ab Memorypointer starten *)
PROCEDURE ml4_start_pgm;
VAR input : byte;
BEGIN
  input:=$24;
  macro_0(@INPUT,1);
END;


(* Byte von Memorypointer lesen und Pointer inkrementieren *)
FUNCTION  ml4_get_ram : BYTE;
var input  : byte;
    output : record
               x,
               b  : byte;
             end;
BEGIN
  input:=$26;
  macro_1(@INPUT,1,@output,2);
  ml4_get_ram:=output.b;
END;



(* Byte an Memorypointer schreiben und Pointer inkrementieren *)
PROCEDURE ml4_put_ram(data : BYTE);
VAR input : record
              c,
              b  : byte;
            end;
BEGIN
  input.c:=$22;
  input.b:=data;
  macro_0(@INPUT,2);
END;



(* Lesen eines Datenbytes von einer I/O-Adresse *)
FUNCTION  ml4_in_port(port : BYTE) : BYTE;
var input  : array [1..2] of byte;
    output : array [1..2] of byte;
BEGIN
  input[1]:=$27;
  input[2]:=port;
  macro_1(@INPUT,2,@output,2);
  ml4_in_port:=output[2];
END;



(* Datenbyte an einen I/O-Port ausgeben *)
PROCEDURE ml4_out_port(port, data : BYTE);
VAR input : array [1..3] of byte;
BEGIN
  input[1]:=$23;
  input[2]:=port;
  input[3]:=data;
  macro_0(@INPUT,3);
END;


(* Multi-Tasking Befehle *)

(* Installieren eines ROM-Programms *)

PROCEDURE ml4_install_rom_task(task,pgm : BYTE;datasize : WORD);
VAR input : record
              c,
              tasknr,
              pgmnr,
              dummy  : byte;
              d_size : word;
            end;
BEGIN
  input.c:=$60;
  input.tasknr:=task;
  input.pgmnr:=pgm;
  input.d_size:=datasize;
  input.dummy:=0;
  macro_0(@INPUT,6);
END;


(* Installieren einer geladenen Task im RAM *)
PROCEDURE ml4_install_ram_task(task : BYTE;adr,datasize : WORD);
VAR input : record
              c,
              tasknr : BYTE;
              adr,
              daten  : WORD;
            end;
BEGIN
  input.c:=$60;
  input.tasknr:=task;
  input.adr:=adr;
  input.daten:=datasize;
  macro_0(@INPUT,6);
END;



(* Verbinden zweier Tasks *)
PROCEDURE ml4_concat_task(task1,task2 : BYTE);
var input  : array [1..3] of byte;
BEGIN
  input[1]:=$61;
  input[2]:=task1;
  input[3]:=task2;
  macro_0(@INPUT,3);
END;



(* Inaktivieren einer Task *)
PROCEDURE ml4_sleep_task(task : BYTE);
var input  : array [1..2] of byte;
BEGIN
  input[1]:=$62;
  input[2]:=task;
  macro_0(@INPUT,2);
END;



(* Aktivieren einer Task *)
PROCEDURE ml4_wakeup_task(task : BYTE);
var input  : array [1..2] of byte;
BEGIN
  input[1]:=$72;
  input[2]:=task;
  macro_0(@INPUT,2);
END;



(* Melde, ob und wie oft eine Task aktiviert ist *)
FUNCTION ml4_get_active_task(task : BYTE) : BYTE;
var input  : array [1..2] of byte;
    output : array [1..3] of byte;
BEGIN
  input[1]:=$73;
  input[2]:=task;
  macro_2(@INPUT,2,@output,3);
  ml4_get_active_task:=output[3];
END;



(* Melde Programmnummer, wenn Programm im ROM vorhanden *)

FUNCTION  ml4_rom_pgm(pgm : BYTE) : BYTE;
var input  : array [1..2] of byte;
    output : array [1..2] of byte;
BEGIN
  input[1]:=$63;
  input[2]:=pgm;
  macro_1(@INPUT,2,@output,2);
  ml4_rom_pgm:=output[2];
END;




(******   Taskorientierte Makro-Implementationen ohne Taskvorwahl *********)


(* Melden der Nummer eines Programms, das unter der angegebenen Task installiert ist *)
FUNCTION  ml4_get_pgm_installed(task : BYTE) : BYTE;
var input  : array [1..2] of byte;
    output : array [1..3] of byte;
BEGIN
  input[1]:=$64;
  input[2]:=task;
  macro_2(@INPUT,2,@output,3);
  ml4_get_pgm_installed:=output[3];
END;



(* Pointer fr Datenbereich setzen *)

PROCEDURE ml4_set_dat_pointer(task : BYTE;adr : WORD);
var input : array [1..4] of byte;
BEGIN
  IF adr = 0 THEN BEGIN      { Setzt Datenpointer auf den Anfang
                               des Datenbereichs der Task }
    input[1]:=$66;
    input[2]:=task;
    macro_0(@INPUT,2);
  END ELSE BEGIN             { Setzt Datenpointer auf adr, relative zum
                               Anfang des Datenbereichs der Task }
    input[1]:=$67;
    input[2]:=task;
    input[3]:=lo(adr);    { Adresse (Low) }
    input[4]:=hi(adr);    { Adresse (High) }
    macro_0(@INPUT,4);
  END;
END;



(* Datenbyte einer Task lesen *)

FUNCTION  ml4_get_dat_byte(task : BYTE) : BYTE;
var input  : array [1..2] of byte;
    output : array [1..3] of byte;
BEGIN
  input[1]:=$68;
  input[2]:=task;
  macro_2(@INPUT,2,@output,3);
  ml4_get_dat_byte:=output[3]; {Datenbyte}
END;



(* Datenbyte einer Task setzen *)

PROCEDURE ml4_set_dat_byte(task, data : BYTE);
var input  : array [1..3] of byte;
BEGIN
  input[1]:=$69;
  input[2]:=task;
  input[3]:=data;   {Datenbyte}
  macro_0(@INPUT,3);
END;



(* Datenwort einer Task lesen *)

FUNCTION  ml4_get_dat_word(task : BYTE) : WORD;
var input  : array [1..2] of byte;
    output : record
               x : array [1..2] of byte;
               w : integer;
             end;
BEGIN
  input[1]:=$6A;
  input[2]:=task;
  macro_2(@INPUT,2,@output,4);
  ml4_get_dat_word:=output.w;	{ Funktionszuweisung }
END;



(* Datenwort einer Task setzen *)

PROCEDURE ml4_set_dat_word(task : BYTE;data : WORD);
var input  : array [1..4] of byte;
BEGIN
  input[1]:=$6B;
  input[2]:=task;
  input[3]:=lo(data);   { Datenwort (Low)}
  input[4]:=hi(data);   { Datenwort (High)}
  macro_0(@INPUT,4);
END;



(* Parameter (BYTE) einer Task lesen *)

FUNCTION  ml4_get_par_byte(task, parameter : BYTE) : BYTE;
var input  : array [1..3] of byte;
    output : array [1..3] of byte;
BEGIN
  input[1]:=$6C;
  input[2]:=task;
  input[3]:=parameter;
  macro_2(@INPUT,3,@output,3);
  ml4_get_par_byte:=output[3];
end;



(* Parameter (BYTE) einer Task setzen *)

PROCEDURE ml4_set_par_byte(task, parameter, value : BYTE);
var input  : array [1..4] of byte;
BEGIN
  input[1]:=$6D;
  input[2]:=task;
  input[3]:=parameter;  { Parameter-Nummer }
  input[4]:=value;	{ Parameterwert }
  macro_0(@INPUT,4);
END;


(* Parameter (Wort) einer Task lesen *)

FUNCTION  ml4_get_par_word(task, parameter : BYTE) : WORD;
var input  : array [1..3] of byte;
    output : record
               x : array [1..2] of byte;
               w : word;
             end;
BEGIN
  input[1]:=$6E;
  input[2]:=task;
  input[3]:=parameter;
  macro_2(@input,3,@output,4);
  ml4_get_par_word:=output.w; { Funktionszuweisung }
END;



(* Parameter (Wort) einer Task setzen *)

PROCEDURE ml4_set_par_word(task, parameter : BYTE; value : WORD);
var input  : array [1..5] of byte;
BEGIN
  input[1]:=$6F;
  input[2]:=task;
  input[3]:=parameter; 		{ Parameter-Nummer }
  input[4]:=lo(value);		{ Parameterwert (Low) }
  input[5]:=hi(value);		{ Parameterwert (High) }
  macro_0(@INPUT,5);
END;




(* Starten einer Prozedur einer Task *)

PROCEDURE ml4_call_proc(task, proc : byte);
var input  : array [1..3] of byte;
BEGIN
  input[1]:=$65;
  input[2]:=task;
  input[3]:=proc;        { Nummer der Prozedur }
  macro_0(@INPUT,3);
END;



(* Block von Daten lesen *)

PROCEDURE ml4_task_block_read(task : BYTE; blocksize : WORD; VAR data);
BEGIN
  inline($8A/$5E/<task);       {MOV BL,[BP+OFS8]}
  inline($8B/$4E/<blocksize);  {MOV CX,[BP+OFS8]}
  inline($8B/$7E/<data);       {MOV DI,[BP+OFS8]}
  inline($8E/$46/<data+2);     {MOV ES,[BP+OFS8]}
  FUNK039;
END;



(* Block von Daten schreiben *)

PROCEDURE ml4_task_block_write(task : BYTE; blocksize : WORD; VAR data);
BEGIN
  inline($1E); 			{PUSH DS}
  inline($8A/$5E/<task);     	{MOV BL,[BP+OFS8]}
  inline($8B/$4E/<blocksize);  	{MOV CX,[BP+OFS8]}
  inline($8B/$76/<data);      	{MOV SI,[BP+OFS8]}
  inline($8E/$5E/<data+2);    	{MOV DS,[BP+OFS8]}
  FUNK038;
  inline($1F); 		{POP DS}
END;


(****************************************************************************)

var  i : integer;

BEGIN   {Haupt- bzw. Initialisierungteil der Unit ML4BIB}
  fillchar(ml4_error_info,sizeof(ml4_error_info),0);
  exitsave:=exitproc;                       {Original-Exitzeiger retten}
  exitproc:=@ml4_exit;                      {neue Exit-Prozedur}
  for i:=1 to 7 do  hardintused[i]:=false;  {Initialisierung}
  getintvec(softint,savesoftint);           {alten Softinterruptvektor retten}
  setintvec(softint,@FUNK000);              {Softinterrupvektor f. Treiber}
END.
