unit util;

interface

USES crt,dos;

function bit(b:byte) : string;
FUNCTION Hex(DEZ:integer):string; {Hilfsfunktion fr Hexadezimale Ausgabe}
FUNCTION Long_Hex(DEZ:longint):string; {Hilfsfunktion fr Hexadezimale Ausgabe}
FUNCTION Dez(Zahl:integer):string; {Hilfsfunktion fr dezimale Ausgabe}
procedure hex_dez(s:string; var ergebnis:word; var code:integer);
procedure stoppuhr(funktion : byte);

PROCEDURE SETXY(X,Y : BYTE);
procedure swrite(s : string); {Direct write to screen mit Cursor SCREENX, SCREENY}
FUNCTION SSTR(WERT : LONGINT) : STRING;

TYPE
   ScreenForm = array [1..25,1..80,1..2] of char;   {Bildschirm}

var systicks : longint absolute $40:$6C;
    laufzeit : real;
    screen   : screenForm absolute $b800:$000; {Bildschirmadresse fr EGA,VGA}


implementation


function bit(b:byte) : string;
var j,itemp : integer;
    s : string;
begin
  s[0]:=#8; itemp:=b;
  for j:=1 to 8 do begin
    if itemp and 128 > 0 then s[j]:='1' else s[j]:='0';;
    itemp:=itemp shl 1;
  end;
  bit:=s;
end;

FUNCTION Hex(DEZ:integer):string; {Hilfsfunktion fr Hexadezimale Ausgabe}
VAR s   : string;
    i,a : integer;
const stellen = #2;
BEGIN
  s[0]:=stellen;
  FOR i:=ord(stellen) downto 1 do BEGIN
    a:=dez mod 16;
    dez:=dez div 16;
    IF a<10 then s[i]:=char(ord('0')+ ord(a))
            ELSE s[i]:=char(ord('A')+ ord(a)-10);
  END;
  s[0]:=stellen;
  hex:=s;
END;

FUNCTION Long_Hex(DEZ:longint):string; {Hilfsfunktion fr Hexadezimale Ausgabe}
VAR s   : string;
    i   : integer;
    a   : longint;
const stellen = #8;
BEGIN
  s[0]:=stellen;
  FOR i:=ord(stellen) downto 1 do BEGIN
    a:=dez mod 16;
    dez:=dez div 16;
    IF a<10 then s[i]:=char(ord('0')+ ord(a))
            ELSE s[i]:=char(ord('A')+ ord(a)-10);
  END;
  s[0]:=stellen;
  Long_hex:=s;
END;


FUNCTION Dez(Zahl:integer):string; {Hilfsfunktion fr dezimale Ausgabe}
VAR s   : string;
    i   : integer;
BEGIN
  str(Zahl:5,s);
  while (s[1]=' ') and  (length(s)> 0) do s:=copy(s,2,255);
  dez:=s;
END;




function zeit : string;
var  hh,mm,ss,msec : word;
  function Strword(w : word) : string;
  var
      sx   : string[20];
  begin
    str(w:2,sx);
    Strword:=sx;
  end;
begin
  gettime(hh,mm,ss,msec);
  zeit:=strword(hh)+':'+strword(mm)+':'+strword(ss)+':'+strword(msec);
end;

procedure stoppuhr(funktion : byte);
const
    starttime : longint = 0;
    stoptime  : longint = 0;
    difftime  : longint = 0;

begin
  case funktion of
    1: starttime:=systicks;
    2: stoptime:=systicks;
    3: begin
         difftime:=stoptime-starttime;
         laufzeit:=difftime / 18.2065;
         write(laufzeit:6:2);           {Ausgabe in Sekunden}
    end;
    4: begin
         difftime:=systicks-starttime;
         laufzeit:=difftime / 18.2065;  {Sekunden}
    end;
  else
  end;
end;


CONST
    SCREENX : BYTE = 1; {Typisierte Konstante, nderbar wie Variable}
    SCREENY : BYTE = 1;

(* Prozeduren fr die Ausgabe von Strings auf den Bildschirm durch        *)
(* Schreiben in den Bildschirmspeicher. Zur Verwendung in der Interrupt-  *)
(* Service-Routine. Unerlaubte DOS-Aufrufe in der ISR (z.B. durch Gotoxy) *)
(* werden so vermieden.                                                   *)

PROCEDURE SETXY(X,Y : BYTE);
begin
  if (screenx<1) or (screenx>80) then exit;
  if (screeny<1) or (screeny>25) then exit;
  screenx:=x;
  screeny:=y;
end;

procedure swrite(s : string); {Direct write to screen mit Cursor SCREENX, SCREENY}
var i : integer;
BEGIN
  if length(s)= 0 then exit;
  for i:=1 to length(s) do begin
    screen[screeny,screenx,1]:=s[i];
    inc(screenx);
    if screenx>80 then begin
      screenx:=1;
      inc(screeny);
      if screeny>25 then screeny:=1;
    end;
  end;
END;

FUNCTION SSTR(WERT : LONGINT) : STRING;
VAR S:STRING;
BEGIN
  STR(WERT:6,S);
  SSTR:=S;
END;


procedure hex_dez(s:string; var ergebnis:word; var code:integer);
var i : integer;
    zw,mult: word;
begin
  Ergebnis:=0; mult:=1; code:=0;
  for i:=length(s) downto 1 do begin
    if s[i] in ['0'..'9'] then begin
      zw:=(ord(s[i])-ord('0')) * mult;
      Ergebnis:=Ergebnis+zw;
    end else begin
      s[i]:=upcase(s[i]);
      if s[i] in ['A'..'F'] then begin
       zw:=(ord(s[i])-ord('A')+10) * mult;
       Ergebnis:=Ergebnis+zw;
      end else begin
        code:=i;
        exit;
      end;
    end;
    mult:=mult*16;
  end;
end;


begin
end.







